//dawCalc.js

/***************************************************************************
*	Copyrights - 2005 A-NO-NE Music All rights reserved
*
*	A script to culculate needed disk space for digital audio recording
*	based on bit depth, sample rate, length of time, and number of tracks
*
*	@author Hiroaki Honshuku, Copyright A-NO-NE Music, Boston, MA
*	@version Last_modified: June 29, 2005
*
*****************************************************************************/


/****************************************************************************
*	CALCULATE DISK SPACE
*
*	@return	textfieldName7	numeric value of the total of file size as string
*****************************************************************************/

function convDawValue() 
{
	var base = 0.125;	// base value based on per bit, per sample, per second
	var output = "";
	var label = "";
	
	var bit = parseInt(document.spaceCalc.bit.value);
	var hour = parseInt(document.spaceCalc.hourField.value);
	var minute = parseInt(document.spaceCalc.minField.value);
	var sec = parseInt(document.spaceCalc.secField.value);
	var sr = (parseFloat(document.spaceCalc.sr.value) / 1000);
	var num = parseInt(document.spaceCalc.tkNumField.value);

	document.getElementById("bitText").innerHTML = bit + " bit";
	document.getElementById("srText").innerHTML = sr + "k";

	// test if hour value is valid
	if (isNaN(hour))
	{
		hour = 0;
		document.spaceCalc.hourField.value = 0;
	}
		
	// test if minute value is valid
	if (isNaN(minute))
	{
		minute = 1;
		document.spaceCalc.minField.value = 1;
	}
		
	// test if sec value is valid
	if (isNaN(sec))
	{
		sec = 0;
		document.spaceCalc.secField.value = 0;
	}
		
	// test if track num value is valid
	if (isNaN(num))
	{
		num = 1;
		document.spaceCalc.tkNumField.value = 1;
	}
		
	// time format all to second
	if ((hour != 0) || (minute != 0))
	{		
		sec += ( (hour * 3600) + (minute * 60) );
		hour = 0;
		minute = 0;
	}

	// calculate
	var result = (base * bit * sec * sr * num)/1048.576;
	
	// MB to GB conversion
	if(result > 1001)
	{
		result = result / 1000;
		label = " GB";
	}else{
		label = " MB";
	}

	// format option to round the output
	if(document.spaceCalc.roundOpt.checked)
	{
		output = format((result), 2);
	}
	else
	{
		output = format((result), 8);
	}
			
	document.getElementById("result").innerHTML = output + label;
	
	return false;

}

/**********************************************************
*	Reset
***********************************************************/
function setInit()
{
	document.spaceCalc.bit.value = 24;
	document.getElementById("bitText").innerHTML = "24 bit";
	document.spaceCalc.hourField.value = "0";
	document.spaceCalc.minField.value = "1";
	document.spaceCalc.secField.value = "0";
	document.spaceCalc.sr.value = 44100;
	document.getElementById("srText").innerHTML = "44.1k";
	document.spaceCalc.tkNumField.value = "1";
	document.getElementById("result").innerHTML = "7.94MB";
	
	convDawValue();
}


/*****************************************************/
// SAVING AND RETRIEVING PREFERENCES (Apple original)
/*****************************************************/

// setup() is run when the body loads.  It checks to see if there is a preference for this widget
// and if so, applies the preference to the widget.

function setup()
{
	if(window.widget)		// always check to make sure that you are running in Dashboard
	{
		// The preferences are retrieved:
		var worldString = widget.preferenceForKey("worldString");
		var leftOffset = widget.preferenceForKey("leftOffset");

		if (worldString && worldString.length > 0)  // if the retrieved preferences are not empty,
		{											// they are restored.
			worldText.innerText = worldString;
			worldText.style.left = leftOffset;
		}
	}
}


