// hiroFormat.js

/***********************************************************************************
*	FORMAT OUTPUT TO ROUNDING
*
*	Formats by taking float value then round to the number of given desimal position.
*	Removes the right most number if zero, which makes this better than
*	num.toPrecicion(); method.
*	Also inserts comma at the group of 3 degits.
*
*	@param		str, n		numeric value as string, number of decimal position
*	@return		str			formatted numeric value as astring
*************************************************************************************/

function format(str, n)
{
	var numOfDeci = n + 1;
	// convert to string in order to separate at decimal
	var inputStr = str.toString();
	var deciPos = inputStr.indexOf('.');
	var preStr = "";	// before period
	var posStr = "";	// after period
	var dot = "";		// period identifier
	var lastZero = 0;	// zero identifier
	
	try 
	{
		if(deciPos != -1) // if input value has decimal value
		{
			preStr = inputStr.substring(0, deciPos);	// before period
			posStr = inputStr.substring((deciPos + 1), (inputStr.length));	// after period
			dot = ".";	// store presence of period
		}
		else 
		{
			preStr = inputStr;
			posStr = "";
			dot = "";
		}

		var preNum = parseInt(preStr);
		
		if(preNum != 0) 
		{
			var delimNum = new String(preNum);
			var CommaDelimiter = ",";
			
			// if interger portion is more than 3 degits then insert comma
			for (var i = 0; i < Math.floor((delimNum.length-(1+i))/3); i++) 
			{
				delimNum = delimNum.substring(0,delimNum.length-(4*i+3)) +
				CommaDelimiter + delimNum.substring(delimNum.length-(4*i+3));
			}
			preStr = (delimNum + "");
			posStr = posStr.substring(0, numOfDeci);	// trancates decimal value at the given postion
		}
		else 
		{			
			while(posStr.charAt(lastZero) == '0') 
			{
				lastZero++;
			}
			posStr = posStr.substring(0, (lastZero + 3));
		}

		var lastNum = posStr.charAt(posStr.length -1);		

		// test the left most number to be truncated and round it
		if((posStr.length - lastZero) > 2) 
		{
			if(lastNum < 5) 
			{
				posStr = posStr.substring(0, (posStr.length -1));
			}
			else 
			{
				posStr = posStr.substring(0, (posStr.length -1));
				var tempNum = parseInt((posStr.charAt(posStr.length -1))) + 1;
				posStr = (posStr.substring(0, (posStr.length -1))) + tempNum;
			}
		}

		do 
		{
			if(posStr.charAt(posStr.length -1) == '0') 
			{
				posStr = posStr.substring(0, (posStr.length -1));
			}
		} while(posStr.charAt(posStr.length -1) == '0');
		
		// test if there still is decimal value present or remove period
		if(posStr.length == 0) 
		{
			dot = "";
		}
	}
	catch(e) 
	{
		alert("Format error \n" + e);
	}
	return (preStr + dot + posStr);
}
